#!/usr/local/bin/perl

use feature qw(say);
use strict;
use warnings;
use Import::Into;
use Module::Runtime qw(require_module);

my $pkg_num = 0;

sub _parse_use_line ($) {
    local $_ = $_[0];
    my @ret = eval "@{[ s/use ([A-Za-z0-9_:]+)/'$1',/r ]}";
    die "$_ $@" if $@;
    @ret ? \@ret : ();
}

for (map { split /\s*;\s*/ } @ARGV) {
    my $ret = _parse_use_line $_ or next;
    my ($class, @args) = @$ret;
    my $pkg = "pkg$pkg_num";
    $INC{"$pkg.pm"} = 1;

    unless (@args) {
        require_module $class;
        no strict 'refs';
        @args = @{"${class}::EXPORT"};
        @args = @{"${class}::EXPORT_OK"} unless @args;
        die "\@${class}::EXPORT is empty" unless @args;
    }

    $class->import::into($pkg, @args);

    print "use autouse '$class', qw(";
    for (0..$#args) {
        my $f = $args[$_];
        print $f;
        my $code = $pkg->can($f) or die;
        if ( my $str = prototype $code ) {
            print "($str)";
        }
        print " " unless $_ == $#args;
    }
    print ");\n";
}
